# ERC-4337 Account Abstraction Library

A Python library for managing and deploying smart contracts aligned with the ERC-4337 standard. This library simplifies working with Account Abstraction (AA) wallets, smart contract deployment, and transaction encoding for Ethereum networks.

---

## Features

- **Smart Contract Deployment**: Deploy multiple smart contracts dynamically from Solidity source files.
- **Account Abstraction**: Supports ERC-4337 AA wallet management and transaction handling.
- **USDT Transfers**: Generate bytecode for ERC-20 token transfers (e.g., USDT) and deploy them.
- **Dynamic Bytecode Generation**: Build bytecode for specific contract function calls with parameters.
- **Web3 Integration**: Fully compatible with the Web3.py library for seamless blockchain interactions.

---

## Installation

1. Install AbstractGenie from PyPI:
   ```bash
   pip install AbstractGenie

## License
This project is licensed under the MIT License. See the LICENSE file for details.

## Contact
Email: alibertay@gmail.com